/*******************************************************************************
 * SoftTimer example
 *
 * In the public domain.
 *
 * v1.0, 25 Aug 2016  Volker Kuhlmann
 *   Created.
 * v1.1, 05 Sep 2016  Volker Kuhlmann
 *   Renamed to SoftTimer. Show event times.
 *******************************************************************************
 */

#include <SoftTimer.h>

SoftTimer timer;
SoftTimer timer2;

void setup() {
  Serial.begin(115200);
  Serial.println("\r\nSoftTimer example\r\n");
}

void loop() {
  if (millis() <= 2000) { // some condition
    // Start timer (repeatedly) during first 2s of runtime.
    timer.start(1000);
  }
  if (timer.is_expired()) {
    Serial.print("timer expired, at ms "); Serial.println(millis());
    timer.start(1500);
  }

  // For regular intervals:
  // Note the interval() timing is elapsed immediately at first call.
  if (timer2.interval(2000)) {
    Serial.print("2s interval elapsed, at ms "); Serial.println(millis());
  }

  // NOTE:
  // .start() and .interval() take a 2-byte argument (up to 65565 milliseconds),
  // which is most common.
  // For delays larger than 65565 ms use .startW() and .intervalW().
  // For delays up to 255 ms use .startN() and .intervalN(), which gives shorter
  // programs.
}
